--Corrige exo 5.3 schema physique 2 
-- solutions universelles

--Creation des types et des tables
CREATE TYPE segment2_type AS OBJECT
 (ind_IP varchar2(11), longueur number)
/
CREATE TYPE bureau2_type AS OBJECT
 (nbureau varchar2(5), capacite number, etage number)
/
CREATE TYPE traverse2_type AS OBJECT
 (seg REF segment2_type, bur REF bureau2_type)
/
CREATE OR REPLACE TYPE poste_travail2_type AS OBJECT
 (nserie varchar2(5), adrIP varchar2(3), typeposte varchar2(8))
/
CREATE TYPE contient2_type AS OBJECT
 (localisation REF bureau2_type, connexion REF poste_travail2_type)
/
CREATE TYPE connecte2_type AS OBJECT
 (cable REF segment2_type, machine REF poste_travail2_type)
/
CREATE TYPE logiciel2_type AS OBJECT
 (codelogi varchar2(5), nomlogi varchar2(10),
  version varchar2(10), dateachat date, typeOS varchar2(8))
/
CREATE TYPE installe2_type AS OBJECT
 (logi REF logiciel2_type, poste REF poste_travail2_type,
  dateinst date)
/

CREATE TABLE segment2 OF segment2_type
 (CONSTRAINT pk_segment2 PRIMARY KEY(ind_IP));

CREATE TABLE bureau2 OF bureau2_type
 (CONSTRAINT pk_bureau2 PRIMARY KEY(nbureau));

CREATE TABLE traverse2 OF traverse2_type;

CREATE TABLE poste_travail2 OF poste_travail2_type 
 (CONSTRAINT pk_poste2 PRIMARY KEY(nserie));

CREATE TABLE contient2 OF contient2_type;

CREATE TABLE connecte2 OF connecte2_type;

CREATE TABLE logiciel2 OF logiciel2_type
 (CONSTRAINT pk_logiciel2 PRIMARY KEY(codelogi));

CREATE TABLE installe2 OF installe2_type;

--Suppression des tables et des types
DROP TABLE installe2;
DROP TABLE logiciel2;
DROP TABLE connecte2;
DROP TABLE contient2;
DROP TABLE poste_travail2;
DROP TABLE traverse2;
DROP TABLE bureau2;
DROP TABLE segment2;
DROP TYPE installe2_type;
DROP TYPE logiciel2_type;
DROP TYPE connecte2_type;
DROP TYPE contient2_type;
DROP TYPE poste_travail2_type;
DROP TYPE traverse2_type;
DROP TYPE bureau2_type;
DROP TYPE segment2_type;