-- Annexe 2
-- Corrige exercice 7.2 Schema 1

--Monotable en relationnel

--1. Affichage des postes de type Windows
--schema 1 :
SELECT	nserie 
	FROM poste_travail1
	WHERE typeposte LIKE 'Win%';

--pareil schema 2:
SELECT	nserie 
	FROM poste_travail2
	WHERE typeposte LIKE 'Win%';

-- 2 Postes, adresse IP
--schema 1 :
SELECT	p.nserie "Poste", 
 	p.connexion.ind_IP || '.' || p.adrIP "Adresse IP"
	FROM poste_travail1 p
	ORDER BY p.connexion.ind_IP || p.adrIP;

--schema 2 :
SELECT	c.machine.nserie "Poste", 
	c.cable.ind_IP || '.' || c.machine.adrIP "Adresse IP"
  	FROM connecte2 c
	ORDER BY c.cable.ind_IP || c.machine.adrIP;

-- 3- Num bureaux parcourus par le segment 130.40.32
--mauvaise solution schema 1 :
SELECT	DISTINCT(p.localisation.nbureau) "Local"
	FROM poste_travail1  p
	WHERE p.connexion.ind_IP = '130.40.32';

--bonnes solutions
--schema 1 :
SELECT b.nbureau "Local" FROM bureau1 b
	WHERE EXISTS 
	((SELECT nestedbur.seg.ind_IP 
	  FROM THE(SELECT b2.segments 
			FROM bureau1 b2 
			WHERE b2.nbureau=b.nbureau) nestedbur)
	INTERSECT
	(SELECT s.ind_IP FROM segment1 s WHERE s.ind_ip = '130.40.32'));

--schema 2 :
SELECT	t.bur.nbureau "Local"
	FROM traverse2 t 
	WHERE t.seg.ind_IP = '130.40.32';


-- 4 Num segments parcourant bureau b4
--schema 1 :
SELECT	nestedseg.seg.ind_IP "Cables (b4)"
	FROM THE (SELECT b.segments FROM bureau1 b
		  WHERE b.nbureau = 'b4') nestedseg
	ORDER BY 1;
--schema 2 :
SELECT	t.seg.ind_IP "Cables (b4)"
	FROM traverse2 t
	WHERE t.bur.nbureau = 'b4'
	ORDER BY 1;

-- 5 Num segments parcourant b4 et b3
--schema 1 :
SELECT	nestedseg.seg.ind_IP "Cable b3-b4"
	FROM THE (SELECT b.segments FROM bureau1 b 
		  WHERE b.nbureau = 'b3') nestedseg
	INTERSECT
SELECT	nestedseg.seg.ind_IP
	FROM THE (SELECT b.segments FROM bureau1 b
		  WHERE b.nbureau = 'b4') nestedseg;

--schema 2 :
SELECT	t.seg.ind_IP "Cable b3-b4"
	FROM traverse2 t
	WHERE t.bur.nbureau = 'b3'
INTERSECT
SELECT	t.seg.ind_IP 
	FROM traverse2 t
	WHERE t.bur.nbureau = 'b4';

-- 6 Nbre logiciel de type Windows 95
--schema 1 :
SELECT	COUNT(*) "Nombre logiciels Windows 95"
	FROM logiciel1
	WHERE typeOS = 'Win95';

--meme requete schema 2 :
SELECT	COUNT(*) "Nombre logiciels Windows 95"
	FROM logiciel2
	WHERE typeOS = 'Win95';

-- 7 Nbre de logiciels installes par poste
--schema 1 : PL/SQL

SELECT	i.poste.nserie, COUNT(i.poste) "Nbre logi"
	FROM installe2 i
	GROUP BY i.poste;

--8 Postes du bureau 'b3'
--1ere solution schema 1 :
SELECT	p.nserie "Bur.3"
	FROM poste_travail1 p
	WHERE p.localisation.nbureau = 'b3';

--2eme solution schema 1 :
SELECT	nestedequipement.poste_t.nserie "Bur.3"
	FROM THE(SELECT equipements
		 FROM bureau1
		 WHERE nbureau = 'b3') nestedequipement;

--schema 2 :
SELECT	c.connexion.nserie "Bur.3"
	FROM contient2 c
	WHERE c.localisation.nbureau = 'b3';


-- 9 Nbre de postes par bureau
--schema 1 :
SELECT	p.localisation.nbureau, 
	COUNT(p.localisation) "Nbre postes"
	FROM poste_travail1 p
	GROUP BY p.localisation.nbureau
	ORDER BY 2;

--schema 2 :
SELECT	c.localisation.nbureau, 
	COUNT(c.connexion.nserie) "Nbre postes"
	FROM contient2 c
	GROUP BY c.localisation.nbureau
	ORDER BY 2;

-- 10 Nbre d'installation du logiciel 'log6'
--schema 1 :
SELECT 	COUNT(*) "Nbre logiciels pour log 6"
	FROM THE(SELECT installations FROM logiciel1 
		 WHERE codelogi = 'log6');

--schema 2 :
SELECT	COUNT(i.logi) "Nbre logiciels pour log 6"
	FROM installe2 i
	WHERE i.logi.codelogi = 'log6';


-- 11 Nbre d'installation par logiciel
--schema 1 : PL/SQL

--schema 2 :
SELECT	i.logi.codelogi "Logi", 
	COUNT(i.logi) "Nbre"
	FROM installe2 i
	GROUP BY i.logi;

-- 12 Nom logiciel avec date achat la plus recente
--schema 1 :
SELECT	nomlogi "+ recent"
	FROM  logiciel1
	WHERE dateachat = (SELECT MAX (dateachat) FROM logiciel1);

--meme requete schema 2 :
SELECT	nomlogi "+ recent"
	FROM  logiciel2
	WHERE dateachat = (SELECT MAX (dateachat) FROM logiciel2);

-- 13 Logiciels ayant + de 2 installations
--schema 1 :
COLUMN codelogi FORMAT A30 HEADING "Logiciels sur + de 2 postes"
SELECT	l1.codelogi FROM logiciel1 l1
	WHERE 3<=
	(SELECT COUNT(*) FROM THE(SELECT installations
		 FROM logiciel1 l
		 WHERE l.codelogi = l1.codelogi));
CLEAR COLUMNS

--schema 2 :
COLUMN logi.codelogi FORMAT A30 HEADING "Logiciels sur + de 2 postes"
SELECT	i.logi.codelogi
	FROM  installe2 i
	GROUP BY i.logi
	HAVING COUNT(i.logi) >= 3;
CLEAR COLUMNS

-- 14 Logiciel et nombre d'installations ayant + de 3 installations
--schema 1 : PL/SQL

--schema 2 :
COLUMN logi.codelogi FORMAT A30 HEADING "Logiciels sur + de 2 postes"
SELECT	i.logi.codelogi,COUNT(i.logi) "Nombre d'installations"
	FROM  installe2 i
	GROUP BY i.logi
	HAVING COUNT(i.logi) >= 3;
CLEAR COLUMNS

-- 15 Nombre de logiciels avec + de 2 installations
--schema 1 :
SELECT	COUNT(l1.codelogi) "Nbr. logiciels + de 2 install"
	FROM logiciel1 l1
	WHERE 3<=
	(SELECT COUNT(*) FROM THE(SELECT installations
		 FROM logiciel1 l
		 WHERE l.codelogi = l1.codelogi));

--schema 2 :
SELECT	COUNT(COUNT(*)) "Nbr. logiciels + de 2 install"
	FROM  installe2 i
	GROUP BY i.logi
	HAVING COUNT(i.logi) >= 3;


-- 16 Numros des postes sur lesquels il y a 3 logiciels installs
--schema 1 :   PL/SQL

--schema 2 :
SELECT	i.poste.nserie
	FROM installe2 i
	GROUP BY i.poste
	HAVING COUNT(i.poste) =3;

-- 17 Numros des postes sur lesquels il y a 3 logiciels installs et @IP 02
--schema 1 : Programme  PL/SQL

--schema 2 :
SELECT	i.poste.nserie
	FROM  installe2 i
	WHERE i.poste.adrIP = 2
	GROUP BY i.poste
	HAVING COUNT(i.poste) =3;

-- 18 Nbre de postes a 3 installations
--schema 1 : Programme  PL/SQL

--schema 2 :
SELECT	COUNT(*) "Nbre postes 3 installations" FROM
	(SELECT	i.poste.nserie FROM installe2 i
	GROUP BY i.poste HAVING COUNT(i.poste) =3);